bootstrap.r=function(x,iter)
{# boostrap the mean and variance of sample variance
 # {sum(xi-xbar)^2}/2
 
 mu=numeric()		# store the mean of each bootstrap sample
 s2=numeric()		# store the variance of each bootstrap sample
 
 n=length(x)
 
 for (i in 1:iter) {
 xx=sample(x,n,replace=T)
 mu[i]=mean(xx)
 s2[i]=(sum((xx-mu[i])^2))/n
 }
 
 mean.s2=mean(s2)
 var.s2=var(s2)*(n-1)/n
 
 qu0025.s2=quantile(s2,0.025)
 qu0975.s2=quantile(s2,0.975)
 
 hist(s2)
 
 cat("\ The mean of the variance = ",mean.s2,"\n")
 
 cat("\ The 95% CI = (", qu0025.s2, ",",qu0975.s2,")","\n")
 
 }