he.pmf.r=function (abund,parm,numbin,uppabund,lwd)
{# Calculate pmf of He model, with b=nb+lambda, d=nd+mu
 # plot species-abundance curve using Volkov's binning method. It is not truly Preston's 2^2
 # binning method.
 # If Preston's binning method is required, using another program hh.pmf.main2

 obs.nsp=numeric()
 obs.nsp.perbin=numeric()
 prd.nsp.perbin=numeric()

 alpha=parm[1]
 beta=parm[2]
 x=parm[3]

 n=1:uppabund 

# calculate theta

 theta.inv=sum(exp(lgamma(n+alpha)+lgamma(1+beta)-lgamma(alpha)-lgamma(n+1+beta)+n*log(x)))

 hh.pmf=(1/theta.inv)*exp(lgamma(n+alpha)+lgamma(1+beta)-lgamma(alpha)-lgamma(n+1+beta)+n*log(x))

## count number of species for empirical data following Preston's 2^2 scale
#

 cat("\n probabilities of first two classes = ", hh.pmf[1:2], "\n")

 cat("\n theta =  ",1/theta.inv,"\n")
 
 maxabund=max(abund)

 for (i in 1:maxabund) { 
 obs.nsp[i]=length(abund[abund==i])
 }
  
 obs.nsp.perbin[1]=obs.nsp[1]/2


 for(i in 1:numbin) {
 j=i+1
 bin1=2^(i-1)
 bin2=2^i

 obs.nsp.perbin[j]=sum(obs.nsp[bin1:bin2])-obs.nsp[bin1]/2-obs.nsp[bin2]/2

 if(bin2>maxabund) {bin2=maxabund
 obs.nsp.perbin[j]=sum(obs.nsp[bin1:bin2])
 }
 }

 cat("\n observed number of species = ", sum(obs.nsp.perbin), "\n")
## end of counting number of species for empirical data set
#
## count number of species for estimated Hel model
  
 prd.nsp.perbin[1]=hh.pmf[1]/2
 
 for(i in 1:numbin) {
 j=i+1
 bin1=2^(i-1)
 bin2=2^i
 prd.nsp.perbin[j]=sum(hh.pmf[bin1:bin2])-hh.pmf[bin1]/2-hh.pmf[bin2]/2
 }
 
 prd.nsp.perbin=prd.nsp.perbin*length(abund)

# the follow is to make the last bin of prd.nsp.perbin be a sum for all higher bins
 prd.nsp.perbin[numbin+1]=sum(hh.pmf)*length(abund)-sum(prd.nsp.perbin[-(numbin+1)])

 cat("\n predicted number of species = ", sum(prd.nsp.perbin), "\n")
 
## end of counting number of species for estimated He model
#
## goodness-of-fit

  sum.squares1=sum(((obs.nsp.perbin-prd.nsp.perbin)^2)/prd.nsp.perbin)
  pvalue1=1-pchisq(sum.squares1,numbin-2)
  cat("\n chisq = ", sum.squares1, "    p-value = ", pvalue1, "\n")

  obs.nsp.perbin2=c(obs.nsp.perbin[1:(numbin-2)],sum(obs.nsp.perbin[(numbin-1):numbin]))
  prd.nsp.perbin2=c(prd.nsp.perbin[1:(numbin-2)],sum(prd.nsp.perbin[(numbin-1):numbin]))

  sum.squares2=sum(((obs.nsp.perbin2-prd.nsp.perbin2)^2)/prd.nsp.perbin2)
  pvalue2=1-pchisq(sum.squares2,numbin-3)
  cat("\n chisq = ", sum.squares2, "    p-value = ", pvalue2, "\n")

  plot(c(1:(numbin+1)),obs.nsp.perbin,xlim=c(0.8,numbin+1.25),ylim=c(0.5,max(obs.nsp.perbin)),xlab="",ylab="",lwd=lwd,type="h")
  lines(c(1:(numbin+1)),prd.nsp.perbin,col="red")
  points(c(1:(numbin+1)),prd.nsp.perbin,pch=16,col="red")
 
  data.frame(obs.nsp=obs.nsp.perbin,prd.nsp=prd.nsp.perbin)
}
