mle.logseries.r=function(data, x)
{
# MLE estimation of logseries distribution
# 
# There is one parameter: x
#
#

        startparam <- c(x)
	out <- optim(c(startparam[1]), fn = logseries.llik.obj,n=data)
	x <- out$par[1]
        
        cat("Message: ", out$mes, "\n")
	cat("   x = ", round(x, 5), "\n")
	cat("fn value: ", out$value, "\n")
	cat("convergence: ", out$convergence, "\n")
	
	alpha=-1/log(1-x)
	
	cat("alpha = ",round(alpha,5),"\n")

}



######################################################
# The objective of the logseries likelihood function #
######################################################

logseries.llik.obj=function(param, n)
{

# maximum likelihood estimation of the normal distribution

 s = length(n)

 x = param[1]

 obj.fn=-s*log(-log(1-x))+sum(n*log(x)-log(n))

 -obj.fn

}

