mle.main.r=function(data,dbhcut,nclass, beta, b)
{
# MLE estimation of normal distribution
# 
# There are 2 parameters: mean (mu) and variance (sigma2)
#
#

        startparam <- c(mu, sigma2)
	out <- optim(c(startparam[1], startparam[2]), fn = normal.llik.obj,hessian=T,x=data)
	mu <- out$par[1]
        sigma2 <- out$par[2]
        
        hessian.matrix=out$hessian
        
        print(hessian.matrix)
        
        cat("Message: ", out$mes, "\n")
	cat("   mu = ", round(mu, 5), "\n")
	cat("   sigma2    = ", round(sigma2, 5), "\n")
	cat("fn value: ", out$value, "\n")
	cat("convergence: ", out$convergence, "\n")

}



####################################################
# The objective of the Weibull likelihood function #
####################################################

normal.llik.obj=function(param, data)
{

# maximum likelihood estimation of the normal distribution

 n = length(data)

 mu = param[1]
 sigma2 = param[2]

 term1=-n/2*log(sigma2)
 term2=-sum((data-mu)^2/(2*sigma2))

 obj.fn=term1+term2

 -obj.fn

}

